import RNFetchBlob from 'react-native-fetch-blob';

const fs = RNFetchBlob.fs
const dirs = fs.dirs;
const rootDir = `${dirs.DocumentDir}/react-native-yaimage`;

function clear() {
  return fs.unlink(rootDir);
}

function dirSize(dir) {
  return fs.lstat(dir)
    .then(stats => Promise.all(stats.filter(stat => stat.type === 'directory').map(stat => dirSize(stat.path)))
          .then(sizes => sizes.reduce((sum, size) => sum + size, stats.reduce((sum, stat) => sum + (+stat.size), 0))));
}

function size() {
  return fs.exists(rootDir).then(() => dirSize(rootDir)).catch(() => Promise.resolve(0));
}

const cache = {
  clear,
  size,
};

export default cache;
